﻿Imports System.Runtime.InteropServices

Public Class Form1

    <StructLayout(LayoutKind.Sequential)> Public Class DOC_INFO_1
        <MarshalAs(UnmanagedType.LPStr)> Public pDocName As String
        <MarshalAs(UnmanagedType.LPStr)> Public pDataType As String
        <MarshalAs(UnmanagedType.LPStr)> Public pOutputFile As String
    End Class

    'Win32 API
    Private Declare Function OpenPrinter Lib "winspool.drv" Alias "OpenPrinterA" (ByVal pPrinterName As String, ByRef phPrn As Integer, ByVal pDefault As Integer) As Boolean
    Private Declare Function StartDocPrinter Lib "winspool.drv" Alias "StartDocPrinterA" (ByVal hPrn As Integer, ByVal Level As Integer, ByVal pDocInfo As DOC_INFO_1) As Integer
    Private Declare Function StartPagePrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer
    Private Declare Function WritePrinter Lib "winspool.drv" (ByVal hPrn As Integer, ByVal pBuf As Byte(), ByVal cdBuf As Integer, ByRef pcWritten As Integer) As Integer
    Private Declare Function EndPagePrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer
    Private Declare Function EndDocPrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer
    Private Declare Function ClosePrinter Lib "winspool.drv" (ByVal hPrn As Integer) As Integer

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        If PrintDialog1.ShowDialog() = DialogResult.OK Then
            TextBox2.Text = PrintDialog1.PrinterSettings.PrinterName
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Close()
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        'TEST PRINT

        Dim name As String
        Dim hPrinter As Integer
        Dim Ret As Integer
        Dim di As New DOC_INFO_1
        Dim Written As Integer

        Dim cmd As Byte() = New Byte(16) {}

        Dim str As String
        Dim bytesData As Byte()

        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'Printer Open
        name = TextBox2.Text
        Ret = OpenPrinter(name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        'Print data 
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        'command（Initialization）
        cmd(0) = &H1B
        cmd(1) = &H40
        WritePrinter(hPrinter, cmd, 2, Written)

        'command（S-JIS）
        cmd(0) = &H1C
        cmd(1) = &H43
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)

        '
        str = "PRINT TEST"
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'command（Paper feed）
        cmd(0) = &H1B
        cmd(1) = &H4A
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        'command（Paper cut）
        cmd(0) = &H1B
        cmd(1) = &H69
        WritePrinter(hPrinter, cmd, 2, Written)

        'Print end 
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'Printer close
        ClosePrinter(hPrinter)

    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        'barcode print

        Dim name As String
        Dim hPrinter As Integer
        Dim Ret As Integer
        Dim di As New DOC_INFO_1
        Dim Written As Integer

        Dim cmd As Byte() = New Byte(16) {}

        Dim str As String
        Dim bytesData As Byte()

        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'Printer Open
        name = TextBox2.Text
        Ret = OpenPrinter(name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        'Print start 
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        'command（Initialization）
        cmd(0) = &H1B
        cmd(1) = &H40
        WritePrinter(hPrinter, cmd, 2, Written)

        'command（S-JIS）
        cmd(0) = &H1C
        cmd(1) = &H43
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)

        str = "****** CODE39 TEST ******" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'command（HRI character printing）
        cmd(0) = &H1D
        cmd(1) = &H48
        cmd(2) = &H2
        WritePrinter(hPrinter, cmd, 3, Written)

        'command（barcode height）
        cmd(0) = &H1D
        cmd(1) = &H68
        cmd(2) = &H64
        WritePrinter(hPrinter, cmd, 3, Written)

        'command（barcode width）
        cmd(0) = &H1D
        cmd(1) = &H77
        cmd(2) = &H2
        WritePrinter(hPrinter, cmd, 3, Written)

        'command（CODE39)
        cmd(0) = &H1D
        cmd(1) = &H6B
        cmd(2) = &H4
        WritePrinter(hPrinter, cmd, 3, Written)

        'command（barcode data）
        str = "ABCDEF"
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'NULL(0x00)
        cmd(0) = &H0
        WritePrinter(hPrinter, cmd, 1, Written)

        'command（Paper feed）
        cmd(0) = &H1B
        cmd(1) = &H4A
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        'command（Paper cut）
        cmd(0) = &H1B
        cmd(1) = &H69
        WritePrinter(hPrinter, cmd, 2, Written)

        'Print end 
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'Printer close
        ClosePrinter(hPrinter)

    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        'QR code

        Dim name As String
        Dim hPrinter As Integer
        Dim Ret As Integer
        Dim di As New DOC_INFO_1
        Dim Written As Integer

        Dim cmd As Byte() = New Byte(16) {}

        Dim str As String
        Dim bytesData As Byte()

        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'Printer Open
        Name = TextBox2.Text
        Ret = OpenPrinter(Name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        'Print start 
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        'command（Initialization）
        cmd(0) = &H1B
        cmd(1) = &H40
        WritePrinter(hPrinter, cmd, 2, Written)

        'command（S-JIS）
        cmd(0) = &H1C
        cmd(1) = &H43
        cmd(2) = &H1
        WritePrinter(hPrinter, cmd, 3, Written)

        str = "****** QR CODE TEST ******" & vbLf
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'command（QR code print）
        cmd(0) = &H1D
        cmd(1) = &H51
        cmd(2) = &H6
        cmd(3) = &H4
        cmd(4) = &H4
        cmd(5) = &H14
        cmd(6) = &H0
        WritePrinter(hPrinter, cmd, 7, Written)

        'command（QR code data）
        str = "QRCODE TEST123456789"
        bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
        WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

        'command（Paper feed）
        cmd(0) = &H1B
        cmd(1) = &H4A
        cmd(2) = &H80
        WritePrinter(hPrinter, cmd, 3, Written)

        'command（Paper cut）
        cmd(0) = &H1B
        cmd(1) = &H69
        WritePrinter(hPrinter, cmd, 2, Written)

        'Print end 
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'Printer close
        ClosePrinter(hPrinter)

    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        'Receipt sample

        Dim name As String
        Dim hPrinter As Integer
        Dim Ret As Integer
        Dim di As New DOC_INFO_1
        Dim Written As Integer

        Dim cmd As Byte() = New Byte(16) {}

        Dim cnt As Long

        Dim str As String
        Dim bytesData As Byte()

        di.pDocName = "TEST PRINT"
        di.pOutputFile = vbNullString
        di.pDataType = vbNullString

        'Printer Open
        Name = TextBox2.Text
        Ret = OpenPrinter(Name, hPrinter, 0)
        If Ret = 0 Then
            Return
        End If

        'Print start 
        StartDocPrinter(hPrinter, 1, di)
        StartPagePrinter(hPrinter)

        For cnt = 0 To 0

            'command（Initialization）
            cmd(0) = &H1B
            cmd(1) = &H40
            WritePrinter(hPrinter, cmd, 2, Written)

            'command (Center alignment)
            cmd(0) = &H1B
            cmd(1) = &H61
            cmd(2) = &H1
            WritePrinter(hPrinter, cmd, 3, Written)

            str = "Sample print" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            'command (Left alignment)
            cmd(0) = &H1B
            cmd(1) = &H61
            cmd(2) = &H0
            WritePrinter(hPrinter, cmd, 3, Written)

            str = "------------------------------------" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "sanei elec" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "           TEL:XX-XXXX-XXXX" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "------------------------------------" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "DAY  20XX/XX/XX (SUN)13:00" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "card number XXXXXXXXXXXX0000(IC)" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "Payment classification Single payment" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "------------------------------------" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "Total      \29.8$" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "------------------------------------" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "SANEI TAROU" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "------------------------------------" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "Thank you for the use" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "I am waiting for next coming to the store" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "------------------------------------" & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            str = "sign:" & vbLf & vbLf
            bytesData = System.Text.Encoding.GetEncoding(932).GetBytes(str)
            WritePrinter(hPrinter, bytesData, bytesData.Length, Written)

            'command（Paper feed）
            cmd(0) = &H1B
            cmd(1) = &H4A
            cmd(2) = &H80
            WritePrinter(hPrinter, cmd, 3, Written)

            'command（Paper cut）
            cmd(0) = &H1B
            cmd(1) = &H69
            WritePrinter(hPrinter, cmd, 2, Written)

        Next

        'Print end 
        EndPagePrinter(hPrinter)
        EndDocPrinter(hPrinter)

        'Print close 
        ClosePrinter(hPrinter)

    End Sub
End Class
